(*STDOUT
*)
(*STDERR
*)

let me = Sys.argv.(0)

let id =
  if Array.length Sys.argv > 1 then Sys.argv.(1) else "0"

def echo(x) = Printf.printf "%s: %s\n" id x ; flush stdout ; 0

let s_addr =
  let server = Join.Site.get_local_addr () in
  Unix.ADDR_INET (server, 12345)

let ns = Join.Ns.of_sockaddr s_addr
and s_site = Join.Site.there s_addr

let () = Join.Site.at_fail s_site (def k() = exit 0 ; 0 in k)

let register = 
  (Join.Ns.lookup ns "register" : (string Join.chan -> (string Join.chan) list)) 
let others = register echo

def dead() & lock() = reply to dead

let () =
  if id = "0" then
    let free = (Join.Ns.lookup ns "free" : unit -> unit) in
    begin match Unix.fork () with
    | 0 -> Unix.execv me [| me ; "1"; |]
    | _ ->
	free () ; (* allow server to answer child request *)
        (* Let us hope not to be scheduled out by Unix now! *)
	exit 0    (* and die *)
    end


let () =
  begin match others with
  | [f] ->
      spawn f (id) ;
      let kill_server = (Join.Ns.lookup ns "kill" : unit Join.chan) in
      Thread.delay 10.0 ; (* twice the timeout on connection *)
      spawn kill_server ()
  | _ -> assert false
  end ;
  dead()
;;
