(* Check that connection to a dead runtime does not block
   the connecting runtime *)
(*STDOUT
*)
(*STDERR
*)

let tick,wait = 
  def x () & y () = reply to x
  in y,x
  
let get_and_add, free = 
  def state([]) & get_and_add(x) =
    locked(x) & reply [] to get_and_add 
  or  locked(x) & free() =
    state([x]) & reply to free
  or  state(_::_ as xs) & get_and_add(x) =
    state(x::xs) & reply xs to get_and_add in
  spawn state [];
  get_and_add, free

def register (connect)  =
  let all = get_and_add(connect) in 
  reply all to register

let local_addr = Join.Site.get_local_addr ()

let main =
  Join.Ns.register Join.Ns.here "register" 
    (register: (string Join.chan -> (string Join.chan) list));
  Join.Ns.register Join.Ns.here "free"  (free: unit -> unit);
  Join.Ns.register Join.Ns.here "kill"  (tick: unit Join.chan);
  Join.Site.listen (Unix.ADDR_INET (local_addr, 12345));
  wait() 
