open Unix

let server = ref (gethostname ())
let id = ref "0"
and oid = ref "1"

let () = Arg.parse
  [
   "-bis", Arg.Unit (fun () -> id := "1" ; oid := "0"),
     " adopt other identity" ;
  ] 
  (fun s -> server := s)
  (Printf.sprintf "%s [-opt]* [server]" Sys.argv.(0))

let addr = (gethostbyname !server).h_addr_list.(0)

let ns = Join.Ns.of_sockaddr (ADDR_INET (addr, 12345))

let rec hard_get name =
  try Join.Ns.lookup ns name with
  | Not_found -> Thread.delay 1.0 ; hard_get name


let server = (hard_get "server" : Join.Site.t)

let _ = Join.Site.at_fail server (def e() = exit 0 ; 0 in e)

let tick = (hard_get "tick" : unit Join.chan)

def work(x) = Printf.printf "%s: %i\n" !id x ; flush Pervasives.stdout ; tick()

let _ = Join.Ns.register ns (!id ^ "work") work

  
let owork = (hard_get (!oid ^ "work") : int Join.chan)

let sync = (hard_get ("sync"^ !id) : unit -> unit)

(* Synchronize with other client, at server's site *)
let () = sync ()


(* Since the sync favors simultaneous send below *)
let _ = spawn (owork(int_of_string !id))

def  lock() & dead () = reply to dead


let () = dead()
