open Unix
(* Reciprocal connection, implicit inet identity
   awful hack to pass file description to son's Join.connect *)
(*OUT
0: 1
1: 0
*)

(*ERR
Exit
Exit
*)

(*DIFF OUT ./diffsorted *)

let server = ref (gethostname())
let son = ref false
let fd = ref (-1)

let () =
  Arg.parse
    ["-son",
      Arg.Int (fun x -> son := true ; fd := x), "adopt son behavior"]
    (fun s -> server := s)
    (Printf.sprintf "%s [opt]* [server]" Sys.argv.(0))

let server_addr = (gethostbyname !server).h_addr_list.(0)

let zyva fd id oid =

  let () = Join.connect fd in


  let ns = Ns.connect (ADDR_INET (server_addr, 12345)) in

  let rec hard_get name =
    try Ns.lookup ns name with
    | Not_found -> Thread.delay 1.0 ; hard_get name in

  let server = (hard_get "server" : Join.site) in
  
  def wait () & lock() = reply to wait in

  let () = Join.at_fail server
      (def e() = prerr_endline "Exit" ; lock() in e) in

  let tick = (hard_get "tick" : unit channel) in

  def work(x) =
    Printf.printf "%s: %i\n" id x ; flush Pervasives.stdout ; tick() in

  let () = Ns.register ns (id ^ "work") work in

  
  let owork = (hard_get (oid ^ "work") : int channel) in

  let sync = (hard_get ("sync"^ id) : unit -> unit) in

(* Synchronize with other client *)
  let () = sync () in

(* This favors simultaneous send below *)

  let () = spawn (owork(int_of_string id)) in

  wait()

let _ =
  if not !son then 
    let fd0, fd1 = socketpair PF_UNIX SOCK_STREAM 0 in
    match fork () with
    | 0 ->
        Unix.close fd1 ;
        execv Sys.argv.(0) [| Sys.argv.(0) ; "-son" ;
                             string_of_int (Obj.magic fd0 : int) ; !server |]
    | _ ->
        Unix.close fd0 ;
        zyva fd1 "1" "0" ; ignore (wait()) ; exit 0
  else begin
    let fd0 = (Obj.magic !fd : Unix.file_descr) in
    zyva fd0 "0" "1" ;
    exit 0
  end

