let id = Sys.argv.(1)

type t = unit Join.chan

def echo() = print_endline "coucou" ; 0

def print() = print_endline "coucou" ; reply to print

def dead() & lock() = reply to dead

let addr = Join.Site.get_local_addr ()

let sock1 = Unix.ADDR_INET (addr,12345)
and sock2 = Unix.ADDR_INET (addr,12346)

let rec lookup ns key =
  try Join.Ns.lookup ns key with
  |  Not_found -> Thread.delay 1.0 ; lookup ns key

let () = match id with
| "1" ->
    Join.Site.listen sock1 ;
    let ns = Join.Ns.here in
    Join.Ns.register ns "echo" (echo:t) ;
    Join.Ns.register ns "print" (print:unit -> unit) ;
    Join.Ns.register ns "server" Join.Site.here ;
    def hook(site) = Join.Site.at_fail site lock ; reply to hook in
    Join.Ns.register ns "hook" (hook : Join.Site.t -> unit) ;    
    dead()
| "2" ->
    Join.Site.listen sock2 ;
    let ns = Join.Ns.there sock1 in
    let echo = (lookup ns "echo" : t)
    and print = (lookup ns "print" : unit -> unit)
    and server =  (lookup ns "server" : Join.Site.t)
    and hook = (lookup ns "hook" : Join.Site.t -> unit) in
    hook(Join.Site.here) ;
    Join.Ns.register Join.Ns.here "echo" ( echo : t ) ;
    Join.Ns.register Join.Ns.here "print" ( print : unit -> unit ) ;
    Join.Ns.register Join.Ns.here "kill" ( lock : t ) ;
    Join.Ns.register Join.Ns.here "server" ( server : Join.Site.t ) ;
    spawn echo() ;
    dead()
| "3" ->
    let site = Join.Site.there sock2 in
    let ns = Join.Ns.there sock2 in
    let echo = (lookup ns "echo" : t)
    and kill = (lookup ns "kill" : t) in
    def zyva() = for k = 1 to 1 do echo() done in
    Join.Site.at_fail site zyva ; spawn kill() ;
    spawn (Thread.delay 2.0 ; lock()) ;
    dead()
| "4" ->
    let site = Join.Site.there sock2 in
    let ns = Join.Ns.there sock2 in
    let print = (lookup ns "print" : unit -> unit)
    and kill = (lookup ns "kill" : t) in
    def zyva() =
      (try for k = 1 to 1 do  print() done
      with Join.Exit -> spawn lock()) ; 0 in
    Join.Site.at_fail site zyva ; spawn kill() ;
    dead()
| "5" ->
    let site = Join.Site.there sock2 in
    let ns = Join.Ns.there sock2 in
    let server = (lookup ns "server" : Join.Site.t)
    and kill = (lookup ns "kill" : t) in
    def zyva_server () = print_endline "Dead" ; lock() in
    def zyva() = Join.Site.at_fail server zyva_server ; 0 in
    Join.Site.at_fail site zyva ; spawn kill() ;
    dead()    
| _ -> assert false    
    


