open Printf 

(* Remote communication on three sync channels *)
(*OUT
0
1
2
*)

(*ERR
x=0, y=1, z=2
x=2, y=0, z=1
x=1, y=2, z=0
x=0, y=1, z=2
x=2, y=0, z=1
x=1, y=2, z=0
x=0, y=1, z=2
x=2, y=0, z=1
x=1, y=2, z=0
*)

let () = Join.Site.listen (Unix.ADDR_INET (Join.Site.get_local_addr (), 12345))

let ns = Join.Ns.here

def print(msg, chan) & lock() = 
  output_string chan msg ; output_char chan '\n' ; flush chan ;
  reply to print & lock()

let _ = spawn lock()

def f(x) & g(y) & h(z) =
  print (sprintf "x=%i, y=%i, z=%i" x y z, stderr) ;
  reply x to g & reply y to h & reply z to f

def w() & w'() = reply to w & reply to w'

let _ = Join.Ns.register ns "wfgh" (w', f, g, h)

let print msg = print (msg, stdout)

let _ = print (sprintf "%i" (f(f(f(0))))) ; flush stdout

let _ = print (sprintf "%i" (g(g(g(1))))) ; flush stdout

let _ = print (sprintf "%i" (h(h(h(2))))) ; flush stdout

let _ = try w() with e -> ()
