(* Simple async test *)
open Unix

let server =
  if Array.length Sys.argv > 1 then Sys.argv.(1)
  else gethostname ()

let addr = (gethostbyname server).h_addr_list.(0)

let site = Join.Site.there (ADDR_UNIX "/tmp/coucou")

let ns = Join.Ns.of_sockaddr (ADDR_UNIX "/tmp/coucou")

let show = Join.Ns.lookup ns "show"

def over() & tick() = reply to over

let () = Join.Site.at_fail site tick

def zyva(n) = match n with
| 1 -> show(1, tick)
| _ -> show(n, def k() = zyva(n-1) in k)

let _ = spawn zyva(3)

let _ = over() ; Sys.remove "/tmp/coucou"

