(* Test Join.where_from [server] and Join.there [client] *)
(*OUT
Client talked to me!
*)

let () = Join.Site.listen (Unix.ADDR_INET (Join.Site.get_local_addr (), 12345))

let ns = Join.Ns.here

let rec safe_lookup ns key =
  try Join.Ns.lookup ns key
  with Not_found ->
    Thread.delay 1.0 ;
    safe_lookup ns key

let echo = (safe_lookup ns "echo":unit Join.chan Join.chan Join.chan)

let client_site = Join.Site.where_from echo

let () = Join.Site.at_fail client_site (def k() = exit 0 ; 0 in k)

def dead() & lock() = reply to dead

def k(over) = print_endline "Client talked to me!" ; over()

let () = spawn (echo(k)) ; dead()

