type 'a t = {mutable next : int ; mutable data : 'a array}

let default_size = 32
;;

let create x =
  let t = {next = 1 ; data = Array.create default_size x} in
  t.data.(0) <- x ;
  t

let size t = t.next

let incr_table table new_size =
  let t = Array.create new_size table.data.(0) in
  Array.blit table.data 0 t 0 (Array.length table.data) ;
  table.data <- t

let insert t v =
 let size = Array.length t.data in
 if t.next >= size then
    incr_table t (2*size);
 t.next <- t.next + 1 ;
 let pos = Random.int t.next in
 if pos = t.next-1 then begin
   t.data.(pos) <- v ;
   t.data.(0), t.data.(pos-1)
 end else begin
   for j = t.next-1 downto pos+1 do
     t.data.(j) <- t.data.(j-1)
   done ;
   t.data.(pos) <- v ;
   t.data.(pos+1), t.data.(if pos=0 then t.next-1 else pos-1)
 end
;;


let to_list t =
  let rec do_rec i =
    if i >= t.next then []
    else t.data.(i) :: do_rec (i+1) in
  do_rec 0
