(* Build a diamond of sync calls
   -> one call waiting for another through
      'diamond' of sync calls.
   and test it for transmitting both result and exception
*)

(*OUT
81
*)

(*ERR
A 81
*)

let n =
  if Array.length Sys.argv > 1 then int_of_string Sys.argv.(1)
  else 4

exception A of int

let rec tree f n = match n with
| 0 -> [f]
| _ ->
    List.fold_left
      (fun r g ->
	def f1() & f2() & f3() = 
	  let r = g () in
	  reply r to f1 & reply r to f2 & reply r to f3 in
        f1::f2::f3::r)
      []
      (tree f (n-1))


type 'a res = E of exn | R of 'a

let join f g h () =
  def res1(r1) & res2(r2) & res3(r3) & wait() = reply r1+r2+r3 to wait
  or  exc1(e1) & exc2(e2) & exc3(e3) & wait() =
    reply match e1,e2,e3 with
    | A r1,A r2,A r3 -> raise (A (r1+r2+r3))
    | _,_,_ -> raise Exit 
    to wait in
  let do_spawn f res exc =    
    spawn begin
      match try R (f()) with e -> E e with
      | R r -> res r
      | E e -> exc e
    end in
  do_spawn f res1 exc1 ;
  do_spawn g res2 exc2 ;
  do_spawn h res3 exc3 ;
  wait ()

let zyva = function
| [] -> assert false
| fs ->
    let rec zyva_rec = function
      |	[] -> assert false
      |	[f] -> f
      |	fs  ->
	  let rec do_rec k = function
	    | [] -> zyva_rec k
	    |  [_]|[_;_] -> assert false
	    | f::g::h::rem ->
		do_rec (join f g h::k) rem in
	  do_rec [] fs in
    zyva_rec fs


let pr i = print_int (i()) ; print_newline ()

def f() & res(r) = reply r to f
or  f() & exc(e) = reply raise e to f


let g = zyva (tree f n)

let _ = spawn res(1) ; pr g

let _ =
  spawn exc(A 1) ;
  try pr g with A x -> Printf.eprintf "A %i\n" x

