(* Checking untimely pool entering,
   from a bug report by Wataru Gotoh,
   may fail the test from time to time, but the original
   program failed systematically *)
(*OUT
*)

let opts = Array.to_list (Array.sub Sys.argv 1 (Array.length Sys.argv-1))

let verbose = List.mem "-v" opts

let pre_fork =
  try match opts with
  | [n]|[_;n] -> int_of_string n
  | _ -> raise Exit
  with _ -> 1

let d1 = 1.0 and d2 = 1.0

let t_start = Unix.time ()

let () = at_exit
    (fun () ->
      let t_end = Unix.time () in
      let delta = t_end-.t_start in
      if verbose then Printf.eprintf "%.2f\n" (t_end-.t_start) ;
      if delta > d1 +. d2 +. 1.0  then print_endline "Two slow")

let () = at_exit Join.exit_hook

def f() =
  Thread.delay d2 ;
  if verbose then Join.debug "" "";
  0
def k() = 0

let () =
   (* One threads in pool *)
   spawn for i=1 to pre_fork do k() done ;
   (* Give a real chance to enter pool *)
   Thread.delay d1;
   (* Should have five 'real' threads here *)
   spawn for i = 1 to 5 do f() done


