(*OUT
0 0
1 1
2 2
3 3
4 4
5 5
6 6
7 7
8 8
9 9
*)

def readers(n) & enter_read() = readers(n+1) & reply to enter_read
or  readers(n) & leave_read() = readers(n-1) & reply to leave_read
or  readers(0) & enter_write() = reply to enter_write
and leave_write() = readers(0) & reply to leave_write

let _ = spawn readers(0)


type t = {mutable fst : int ; mutable snd : int }

let t = {fst=0 ; snd=0}


def set(x) =
  enter_write() ;
  t.fst <- x ;
  t.snd <- x ;
  leave_write() ;
  reply  to set

and get() =
  enter_read() ;
  let {fst=y ;snd=z} = t in
  leave_read() ;
  reply y,z to get


def feed() & tick() =
  let x,_ = get() in
  set (x+1) ; feed()

let _ = spawn feed()

let rec do_rec prev n =
  if n > 0 then begin
    let (x,y) = get() in
    if x > prev then begin
      Printf.printf "%i %i\n" x y ; flush stdout ;
      spawn tick() ;
      do_rec x (n-1)
    end else begin
      do_rec prev n
    end
  end



let () = do_rec (-1) 10 ; exit 0
